Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaResolveExpressionsVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaResolveExpressionsVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaResolveExpressionsVisitor.java	(revision 9)
@@ -45,7 +45,6 @@
 import org.momut.ooas.ast.expressions.LeafExpression;
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
 import org.momut.ooas.ast.expressions.TupleConstructor;
@@ -80,10 +79,9 @@
 import org.momut.ooas.ast.types.MapType;
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
 import org.momut.ooas.parser.ParserError;
 import org.momut.ooas.parser.ParserMessage;
@@ -258,7 +256,7 @@
 			if (mid.type() == null || right.type() == null)
 				return Error(expression, "Conditional: Then or Else branch has void-type");
 
-			final UlyssesType acover = UlyssesType.CoverType(mid.type(), right.type());
+			final Type acover = Type.CoverType(mid.type(), right.type());
 
 			if (acover == null)
 				return Error(expression, String.format(
@@ -265,12 +263,12 @@
 					"Conditional: Then and Else branch must be of same type. (%s <> %s)",
 					mid.type().toString(), right.type().toString()));
 
-			if (!UlyssesType.TypeEqual(acover, mid.type()))
+			if (!Type.TypeEqual(acover, mid.type()))
 			{
 				mid = new UnaryOperator(ExpressionKind.Cast, mid, mid.line(), mid.pos());
 				mid.SetType(acover);
 			}
-			if (!UlyssesType.TypeEqual(acover, right.type()))
+			if (!Type.TypeEqual(acover, right.type()))
 			{
 				right = new UnaryOperator(ExpressionKind.Cast, right, right.line(), right.pos());
 				right.SetType(acover);
@@ -322,10 +320,10 @@
 			if (!isMap)
 			{
 				final int nextToLast = funType.parameter().size() - 2;
-				final UlyssesType initCover = UlyssesType.CoverType(funType.parameter().get(nextToLast), mid.type());
+				final Type initCover = Type.CoverType(funType.parameter().get(nextToLast), mid.type());
 				if (initCover == null)
 					return Error(expression, "Next to last parameter does not match initializer type in map operation.");
-				if (!UlyssesType.TypeEqual(mid.type(), initCover))
+				if (!Type.TypeEqual(mid.type(), initCover))
 					mid = new UnaryOperator(ExpressionKind.Cast, mid, mid.line(), mid.pos());
 				mid.SetType(initCover);
 
@@ -336,7 +334,7 @@
 			}
 			// UlyssesType listCover = UlyssesType.CoverType(funType.parameter.Last.Value, ((ListType)right.type).innerType);
 			// if (listCover == null)
-			if (!UlyssesType.TypeEqual(funType.parameter().peekLast(), ((ListType)right.type()).innerType()))
+			if (!Type.TypeEqual(funType.parameter().peekLast(), ((ListType)right.type()).innerType()))
 				return Error(expression, "Last paramter does not match inner-type of list in fold/map operation");
 
 			expression.SetLeftChild(leftcall);
@@ -372,7 +370,7 @@
 	}
 	private Expression ResolveExpression(ListConstructor expression)
 	{
-		UlyssesType type = null;
+		Type type = null;
 		ListType restype = null;
 		Expression comprehension = null;
 		if (expression.comprehension() != null)
@@ -426,7 +424,7 @@
 				if (type == null)
 					type = element.type();
 
-				type = UlyssesType.CoverType(type, element.type());
+				type = Type.CoverType(type, element.type());
 				if (type == null)
 					return Error(expression, "List constructor needs matching types");
 
@@ -436,7 +434,7 @@
 			// now we have the resulting type - we still need to insert casts that might be necessary
 			for (final Expression item: tmpitems)
 			{
-				if (!UlyssesType.TypeEqual(item.type(), type))
+				if (!Type.TypeEqual(item.type(), type))
 				{
 					final Expression cast = new UnaryOperator(ExpressionKind.Cast, item, item.line(), item.pos());
 					cast.SetType(type);
@@ -458,7 +456,7 @@
 	}
 	private Expression ResolveExpression(SetConstructor expression)
 	{
-		UlyssesType type = null;
+		Type type = null;
 		ListType restype = null;
 		Expression comprehension = null;
 		if (expression.comprehension() != null)
@@ -492,7 +490,7 @@
 
 			if (type == null)
 				type = element.type();
-			type = UlyssesType.CoverType(type, element.type());
+			type = Type.CoverType(type, element.type());
 			if (type == null)
 				return Error(expression, "Set initializer needs matching types");
 
@@ -506,8 +504,8 @@
 	}
 	private Expression ResolveExpression(MapConstructor expression)
 	{
-		UlyssesType domain = null;
-		UlyssesType range = null;
+		Type domain = null;
+		Type range = null;
 		final ArrayList<MapConstructor.MapItem> newitems = new ArrayList<MapConstructor.MapItem>();
 
 		for(final MapItem item: expression.items())
@@ -532,8 +530,8 @@
 			if (range == null)
 				range = rangeexpr.type();
 
-			domain = UlyssesType.CoverType(domain, domexpr.type());
-			range = UlyssesType.CoverType(range, rangeexpr.type());
+			domain = Type.CoverType(domain, domexpr.type());
+			range = Type.CoverType(range, rangeexpr.type());
 			if (domain == null)
 				return Error(expression, "Types of domain expressions do not match");
 
@@ -559,11 +557,11 @@
 		//TupleType resulttype = new TupleType(null);
 		final ArrayList<Expression> newvalexprs = new ArrayList<Expression>();
 
-		final Iterator<UlyssesType> innerTargetType = typeToConstruct.innerTypes().iterator();
+		final Iterator<Type> innerTargetType = typeToConstruct.innerTypes().iterator();
 		int freeVarCount = 0;
 		for (final Expression initexpr: expression.values())
 		{
-			final UlyssesType innerTargetTypeValue = innerTargetType.next();
+			final Type innerTargetTypeValue = innerTargetType.next();
 			Expression newval = ResolveExpression(initexpr);
 			if (newval == null)
 				return null;
@@ -580,18 +578,18 @@
 			}
 			else
 			{
-				final UlyssesType acover = UlyssesType.CoverType(innerTargetTypeValue, newval.type());
-				if (acover == null || !UlyssesType.TypeEqualByKind(innerTargetTypeValue, acover))
+				final Type acover = Type.CoverType(innerTargetTypeValue, newval.type());
+				if (acover == null || !Type.TypeEqualByKind(innerTargetTypeValue, acover))
 					return Error(expression,
 						String.format("Element in tuple constructor has non-matching type (%s <> %s)",
 								innerTargetTypeValue.toString(), newval.type().toString()));
 
-				if (!UlyssesType.TypeEqual(acover, newval.type()))
+				if (!Type.TypeEqual(acover, newval.type()))
 				{
 					newval = new UnaryOperator(ExpressionKind.Cast, newval, newval.line(), newval.pos());
 					newval.SetType(acover);
 				}
-				if (UlyssesType.FirstTypeLessRange(innerTargetTypeValue, acover)) {
+				if (Type.FirstTypeLessRange(innerTargetTypeValue, acover)) {
 					Warning(expression,
 						String.format("Tuple constructor may over/underflow: %s := %s",
 								innerTargetTypeValue.toString(), acover.toString()));
@@ -621,33 +619,6 @@
 		return expression;
 	}
 
-	private Expression ResolveExpression(QValConstructor expression)
-	{
-		Expression basevalue = null;
-		Expression rangevalue = null;
-
-		basevalue = ResolveExpression(expression.value()[0]);
-		if (basevalue == null || basevalue.kind() != ExpressionKind.Access
-		    || basevalue.type() == null || basevalue.type().kind() != TypeKind.QrType)
-			return Error(expression, "Landmark expected.");
-		expression.SetType(basevalue.type());
-		expression.SetValue(basevalue);
-
-		if (expression.value().length == 2)
-		{
-			rangevalue = ResolveExpression(expression.value()[1]);
-			if (rangevalue == null || rangevalue.kind() != ExpressionKind.Access
-			    || rangevalue.type() == null || rangevalue.type().kind() != TypeKind.QrType)
-				return Error(expression, "Landmark expected.");
-			if (!UlyssesType.TypeEqual(basevalue.type(), rangevalue.type()))
-				return Error(expression, String.format("Quantity spaces do not match: %s <> %s",
-						basevalue.type().toString(),
-						rangevalue.type().toString()));
-			expression.AddRange(rangevalue);
-		}
-		return expression;
-	}
-
 	private Expression ResolveExpression(IdentifierExpression expression)
 	{
 		// nothing to do here, since we do not have any consts that may be
@@ -836,10 +807,10 @@
 		}
 
 		final ArrayList<Expression> newargs = new ArrayList<Expression>();
-		final Iterator<UlyssesType> demandedArgType = funtype.parameter().iterator();
+		final Iterator<Type> demandedArgType = funtype.parameter().iterator();
 		for (final Expression arg: expression.arguments())
 		{
-			final UlyssesType demandedArgTypeValue = demandedArgType.next();
+			final Type demandedArgTypeValue = demandedArgType.next();
 			Expression newarg = ResolveExpression(arg);
 			if (newarg == null)
 				return null;
@@ -850,14 +821,14 @@
 
 			final Expression constantvalue = newarg.kind() == ExpressionKind.Value ? newarg : null;
 
-			final UlyssesType acover = UlyssesType.CoverType(newarg.type(), demandedArgTypeValue);
-			if (acover == null || !UlyssesType.TypeEqualByKind(demandedArgTypeValue, acover))
+			final Type acover = Type.CoverType(newarg.type(), demandedArgTypeValue);
+			if (acover == null || !Type.TypeEqualByKind(demandedArgTypeValue, acover))
 				return Error(arg, String.format("Argument type does not match; expected: %s delivered: %s",
 						demandedArgTypeValue.toString(), newarg.type().toString()));
 
 			newarg = UnaryOperator.TryCoerceUp(newarg, acover);
 
-			if (UlyssesType.FirstTypeLessRange(demandedArgTypeValue, acover))
+			if (Type.FirstTypeLessRange(demandedArgTypeValue, acover))
 			{
 				if (constantvalue == null)
 				{
@@ -898,7 +869,7 @@
 		final boolean staticAccess = lhs.kind() == ExpressionKind.Type;
 		final UnresolvedIdentifierExpression access = (UnresolvedIdentifierExpression)expression.right();
 		// atype could be null...
-		UlyssesType atype = lhs.type();
+		Type atype = lhs.type();
 		if ((lhs.kind() == ExpressionKind.Call) && (atype == null))
 		{
 			return Error(access, "Can not access return type of void-function");
@@ -984,22 +955,6 @@
 				return Error(access, String.format("%s not contained in enum %s",
 						access.tokenText(), anEnum.identifier().tokenText()));
 			break;
-		case QrType:
-			final QrType aQualitativeType = (QrType)atype;
-			if (!staticAccess)
-			{
-				return Error(access, "QSpace values can only be accessed statically.");
-			}
-			if (aQualitativeType.symbolTable().Defined(access.tokenText()))
-			{
-				final Identifier landmark = aQualitativeType.symbolTable().Get(access.tokenText());
-				final IdentifierExpression newrhs = new IdentifierExpression(landmark, access.line(), access.pos());
-				expression.SetRightChild(newrhs);
-			}
-			else
-				return Error(access, String.format("%s not contained in qspace %s",
-						access.tokenText(), aQualitativeType.identifier().tokenText()));
-			break;
 		default:
 			/*error, we can not access an element with '.' in any other type*/
 			return Error(expression, "Expected: System, Enum, Func, or QR type");
@@ -1174,8 +1129,8 @@
 		if ((lhs == null) || (rhs == null))
 			return null;
 
-		final UlyssesType lt = lhs.type();
-		final UlyssesType rt = rhs.type();
+		final Type lt = lhs.type();
+		final Type rt = rhs.type();
 
 		if ((lt == null) || (rt == null))
 			return Error(expression, "Binary operator not applicable to void-type subexpression.");
@@ -1192,7 +1147,7 @@
 				return Error(expression, "Domain restriction operator expects map on RHS");
 			ListType domlist = (ListType)lt;
 			MapType domMap = (MapType)rt;
-			if (!UlyssesType.TypeEqual(domlist.innerType(), domMap.fromType()))
+			if (!Type.TypeEqual(domlist.innerType(), domMap.fromType()))
 				return Error(expression, "Inner type of list and domain-type of map do not match");
 			// since this is a restriction, maxnumofelems is ok
 			expression.SetType(domMap);
@@ -1205,7 +1160,7 @@
 				return Error(expression, "Rangle restriction operator expects list on RHS");
 			final ListType rangelist = (ListType)rt;
 			domMap = (MapType)lt;
-			if (!UlyssesType.TypeEqual(rangelist.innerType(), domMap.fromType()))
+			if (!Type.TypeEqual(rangelist.innerType(), domMap.fromType()))
 				return Error(expression, "Inner type of list and rangle-type of map do not match");
 			// since this is a restriction, maxnumofelems is ok
 			expression.SetType(domMap);
@@ -1216,8 +1171,8 @@
 				return Error(expression, "Map union expects maps on LHS and RHS");
 			domMap = (MapType)lt;
 			MapType rngMap = (MapType)rt;
-			if (!UlyssesType.TypeEqual(domMap.fromType(), rngMap.fromType()) ||
-					!UlyssesType.TypeEqual(domMap.toType(), rngMap.toType()))
+			if (!Type.TypeEqual(domMap.fromType(), rngMap.fromType()) ||
+					!Type.TypeEqual(domMap.toType(), rngMap.toType()))
 				return Error(expression, "Domain and Range types of maps must be equal");
 			// union may change maximum number of elements..
 			final MapType resMap = new MapType(domMap.fromType(), domMap.toType(),
@@ -1236,7 +1191,7 @@
 				return lhs;
 			if (la.innerType().kind() == TypeKind.Null || la.maxNumberOfElements() == 0)
 				return rhs;
-			if (!UlyssesType.TypeEqual(la.innerType(), lb.innerType()))
+			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
 				return Error(expression, String.format("Set/List concatenation expects two lists of same type. (%s <> %s)", la.toString(), lb.toString()));
 			ListType resultList = new ListType(la.innerType(),
 					la.maxNumberOfElements() + lb.maxNumberOfElements(), null);
@@ -1248,7 +1203,7 @@
 				return Error(expression, "Set difference expects two lists.");
 			la = (ListType)lt;
 			lb = (ListType)rt;
-			if (!UlyssesType.TypeEqual(la.innerType(), lb.innerType()))
+			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
 				return Error(expression, "Set difference expects two lists of same type.");
 			expression.SetType(la);
 			break;
@@ -1258,7 +1213,7 @@
 				return Error(expression, "Set intersection expects two lists.");
 			la = (ListType)lt;
 			lb = (ListType)rt;
-			if (!UlyssesType.TypeEqual(la.innerType(), lb.innerType()))
+			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
 				return Error(expression, "Set intersection expects two lists of same type.");
 			expression.SetType(la.maxNumberOfElements() > lb.maxNumberOfElements() ? la : lb);
 			break;
@@ -1269,8 +1224,8 @@
 			lb = (ListType)rt;
 			if (lhs.kind() == ExpressionKind.Value)
 				lhs = UnaryOperator.TryCoerceUp(lhs, lb.innerType());
-			final UlyssesType leftType = lhs.type();
-			if (!UlyssesType.TypeEqual(leftType, lb.innerType()))
+			final Type leftType = lhs.type();
+			if (!Type.TypeEqual(leftType, lb.innerType()))
 				return Error(expression, String.format("List and element must be of same type: %s in %s",
 						lt == null ? "<null>" : lt.toString(), lb ==null || lb.innerType() == null ? "<null>" : lb.innerType().toString()));
 			expression.SetType(new BoolType(null));
@@ -1281,7 +1236,7 @@
 				return Error(expression, "Subset operation expects two lists.");
 			la = (ListType)lt;
 			lb = (ListType)rt;
-			if (!UlyssesType.TypeEqual(la.innerType(), lb.innerType()))
+			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
 				return Error(expression, "Subset operation expects two lists of same type.");
 			expression.SetType(new BoolType(null));
 			break;
@@ -1297,7 +1252,7 @@
 			if (lb.innerType().kind() == TypeKind.Null || lb.maxNumberOfElements() == 0)
 				return lhs;
 
-			if (!UlyssesType.TypeEqual(la.innerType(), lb.innerType()))
+			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
 				return Error(expression, "Set union expects two lists of same type.");
 			resultList = new ListType(la.innerType(),
 					la.maxNumberOfElements() + lb.maxNumberOfElements(), null);
@@ -1334,7 +1289,7 @@
 				lhs = UnaryOperator.TryCoerceUp(lhs, ((ValuedEnumType)lhs.type()).getIntType());
 			if (rhs.type() instanceof ValuedEnumType)
 				rhs = UnaryOperator.TryCoerceUp(rhs, ((ValuedEnumType)rhs.type()).getIntType());
-			UlyssesType cover = Expression.ArithmeticCover(lt, rt, expression.kind());
+			Type cover = Expression.ArithmeticCover(lt, rt, expression.kind());
 			expression.SetType(cover);
 			break;
 		case minus:
@@ -1373,7 +1328,7 @@
 		case lessequal:
 			if (!((rt.IsNumeric() && lt.IsNumeric()) || (rt.IsQualitative() && lt.IsQualitative())))
 				return Error(expression, "Operator expects LHS and RHS to be numeric or qualitative");
-			cover = UlyssesType.CoverType(lt, rt);
+			cover = Type.CoverType(lt, rt);
 			if (cover != null)
 			{
 				lhs = UnaryOperator.TryCoerceUp(lhs, cover);
@@ -1434,7 +1389,7 @@
 			/*other binary*/
 		case equal:
 		case notequal:
-			cover = UlyssesType.CoverType(lt, rt);
+			cover = Type.CoverType(lt, rt);
 			if (cover != null)
 			{
 				/* see whether we have a tuple-matcher on one side.. */
@@ -1476,7 +1431,7 @@
 				rngMap = (MapType)rt;
 				if (rngMap.fromType().kind() != TypeKind.IntType)
 					return Error(expression, "Domain of map has to be integer");
-				if (!UlyssesType.TypeEqual(domlist.innerType(), rngMap.toType()))
+				if (!Type.TypeEqual(domlist.innerType(), rngMap.toType()))
 					return Error(expression, "Type of list expected to match range of map");
 				// since we only replace elements in the list (by matching ones from the map),
 				// we're save to return the original list..
@@ -1487,8 +1442,8 @@
 			{
 				domMap = (MapType)lt;
 				rngMap = (MapType)rt;
-				if (!UlyssesType.TypeEqual(domMap.fromType(), rngMap.fromType()) ||
-						!UlyssesType.TypeEqual(domMap.toType(), rngMap.toType()))
+				if (!Type.TypeEqual(domMap.fromType(), rngMap.fromType()) ||
+						!Type.TypeEqual(domMap.toType(), rngMap.toType()))
 					return Error(expression, "Maps need same domain and range types");
 				// since we override entries in the first map:
 				expression.SetType(domMap);
@@ -1835,9 +1790,6 @@
 		case ObjectConstr:
 			result = expression;
 			break;
-		case QValConstr:
-			result = ResolveExpression((QValConstructor)expression);
-			break;
 
 			/* identifiers */
 		case Identifier:
@@ -1869,9 +1821,9 @@
 				return Error(cast, String.format("Cast operator needs class type as argument. (Expected: OoActionSystemType, Found: %s)", cast.type().kind().name()));
 
 			cast.SetChild(ResolveExpression(cast.child()));
-			final UlyssesType acover = UlyssesType.CoverType(cast.type(), cast.child().type());
-			final boolean upcast = UlyssesType.TypeEqual(acover, cast.type());           // the cast is safe; Mostly used in list constructors..
-			final boolean downcast = UlyssesType.TypeEqual(acover, cast.child().type()); // downcast, unsafe.
+			final Type acover = Type.CoverType(cast.type(), cast.child().type());
+			final boolean upcast = Type.TypeEqual(acover, cast.type());           // the cast is safe; Mostly used in list constructors..
+			final boolean downcast = Type.TypeEqual(acover, cast.child().type()); // downcast, unsafe.
 			if (downcast)
 				Info(cast, String.format("Potentially unsafe downcast: %s as %s (cover: %s)",
 					cast.child().type().toString(), cast.type().toString(), acover.toString()));
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/optimisation/OoaRemoveTrivialNondetChoiceCompositionVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/optimisation/OoaRemoveTrivialNondetChoiceCompositionVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/optimisation/OoaRemoveTrivialNondetChoiceCompositionVisitor.java	(revision 9)
@@ -39,7 +39,7 @@
 import org.momut.ooas.ast.statements.Statement;
 import org.momut.ooas.ast.statements.StatementKind;
 import org.momut.ooas.ast.types.OoActionSystemType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserState;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
 import org.momut.ooas.utils.exceptions.InternalCompilerException;
@@ -65,7 +65,7 @@
 			switch (parent.nodeType())
 			{
 			case type:
-				switch (((UlyssesType)parent).kind())
+				switch (((Type)parent).kind())
 				{
 				case OoActionSystemType:
 					final OoActionSystemType atype = (OoActionSystemType)parent;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypesVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypesVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypesVisitor.java	(revision 9)
@@ -39,7 +39,7 @@
 import org.momut.ooas.ast.types.MapType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.TupleType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserError;
 import org.momut.ooas.parser.ParserState;
 import org.momut.ooas.utils.exceptions.ArgumentException;
@@ -51,7 +51,7 @@
 /// </summary>
 public final class OoaTypesVisitor extends OoaCompleteAstTraversalVisitor
 {
-	private void Error(UlyssesType aType, String p)
+	private void Error(Type aType, String p)
 	{
 		ParserError error = new ParserError(m_ParserState.filename,
 				aType.identifier().line(), aType.identifier().column(), p);
@@ -58,7 +58,7 @@
 		m_ParserState.AddErrorMessage(error);
 	}
 
-	HashSet<UlyssesType> typesSeen = new HashSet<UlyssesType>();
+	HashSet<Type> typesSeen = new HashSet<Type>();
 
 
 	@Override
@@ -89,12 +89,12 @@
 	}
 
 
-	private interface Action<T extends UlyssesType> {
+	private interface Action<T extends Type> {
 		void doIt(T param);
 	}
 
 	/* Does the check for recursion */
-	private <T extends UlyssesType> void CheckForRecursion(T aType, String Message, Action<T> toCall)
+	private <T extends Type> void CheckForRecursion(T aType, String Message, Action<T> toCall)
 	{
 		if (typesSeen.contains(aType))
 		{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaPrintActionsVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaPrintActionsVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaPrintActionsVisitor.java	(revision 9)
@@ -41,7 +41,7 @@
 import org.momut.ooas.ast.identifiers.NamedActionIdentifier;
 import org.momut.ooas.ast.identifiers.ParameterIdentifier;
 import org.momut.ooas.ast.types.FunctionType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.codegen.prolog.OoaPrologIdentifier;
 import org.momut.ooas.parser.ParserMessage;
 import org.momut.ooas.parser.ParserState;
@@ -160,7 +160,7 @@
 		final StringBuilder parameter = new StringBuilder();
 		if (e.arguments().size() > 0) {
 			int z = 0;
-			for (final UlyssesType ut: actionType.parameter()) {
+			for (final Type ut: actionType.parameter()) {
 				if (e.arguments().size() <= z)
 					continue;
 				Expression arg = e.arguments().get(z);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaCheckASTVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaCheckASTVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/analysis/OoaCheckASTVisitor.java	(revision 9)
@@ -37,7 +37,7 @@
 import org.momut.ooas.ast.statements.SeqBlock;
 import org.momut.ooas.ast.statements.Statement;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserState;
 import org.momut.ooas.utils.exceptions.InternalCompilerException;
 import org.momut.ooas.visitors.OoaCompleteAstTraversalVisitor;
@@ -44,12 +44,12 @@
 
 public final class OoaCheckASTVisitor extends OoaCompleteAstTraversalVisitor {
 	private final String m_tag;
-	private final HashMap<String,UlyssesType> m_seenTypes = new HashMap<>();
+	private final HashMap<String,Type> m_seenTypes = new HashMap<>();
 
 	@Override
 	protected void VisitAstElement(IAst element, IAst parent) {
-		if (element instanceof UlyssesType) {
-			final UlyssesType t = (element instanceof OpaqueType) ? ((OpaqueType) element).resolvedType()  : (UlyssesType) element;
+		if (element instanceof Type) {
+			final Type t = (element instanceof OpaqueType) ? ((OpaqueType) element).resolvedType()  : (Type) element;
 			if (t != null) { // opaque might not have resolve yet..
 				final String typeStr = t.toString();
 				if (m_seenTypes.containsKey(typeStr)) {
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/optimisation/OoaRemoveTrivialPrioritizedCompositionVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/optimisation/OoaRemoveTrivialPrioritizedCompositionVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/optimisation/OoaRemoveTrivialPrioritizedCompositionVisitor.java	(revision 9)
@@ -42,7 +42,7 @@
 import org.momut.ooas.ast.statements.Statement;
 import org.momut.ooas.ast.statements.StatementKind;
 import org.momut.ooas.ast.types.OoActionSystemType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserState;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
 import org.momut.ooas.utils.exceptions.InternalCompilerException;
@@ -66,7 +66,7 @@
 			switch (parent.nodeType())
 			{
 			case type:
-				switch (((UlyssesType)parent).kind())
+				switch (((Type)parent).kind())
 				{
 				case OoActionSystemType:
 					final OoActionSystemType atype = (OoActionSystemType)parent;
